package com.qmth.boot.core.metrics.config.bean;

import com.qmth.boot.core.constant.CoreConstant;
import com.qmth.boot.core.metrics.config.MetricsConfig;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotEmpty;
import java.time.Duration;

@Component
@ConfigurationProperties(prefix = CoreConstant.CONFIG_PREFIX + ".metrics")
@Validated
public class MetricsConfigBean implements MetricsConfig {

    /**
     * 默认时间分组，按0~10ms，10ms~100ms，100ms~500ms，500ms~1s，1s~10s，>10s分为6个档次
     */
    @NotEmpty
    private Duration[] timeGroup = new Duration[] { Duration.ofMillis(10), Duration.ofMillis(100),
            Duration.ofMillis(500), Duration.ofSeconds(1), Duration.ofSeconds(10) };

    public Duration[] getTimeGroup() {
        return timeGroup;
    }

    public void setTimeGroup(Duration[] timeGroup) {
        this.timeGroup = timeGroup;
    }
}
