package com.qmth.boot.core.uid.service.impl;

import com.qmth.boot.core.uid.UidGenerator;
import com.qmth.boot.core.uid.config.UidConfig;
import com.qmth.boot.core.uid.service.UidMachineService;
import com.qmth.boot.core.uid.service.UidService;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;

@Configuration
public class LocalUidService implements UidService {

    @Resource
    private UidConfig uidConfig;

    @Resource
    private UidMachineService uidMachineService;

    private UidGenerator generator;

    @Bean
    @ConditionalOnMissingBean(UidService.class)
    public UidService uidService() {
        return new LocalUidService();
    }

    @PostConstruct
    public void init() {
        this.generator = new UidGenerator(uidConfig.getDatacenterId(), uidMachineService.getMachineId());
    }

    @Override
    public long getId() {
        return generator.next();
    }

    public UidConfig getUidConfig() {
        return uidConfig;
    }

    public void setUidConfig(UidConfig uidConfig) {
        this.uidConfig = uidConfig;
    }

    public UidMachineService getUidMachineService() {
        return uidMachineService;
    }

    public void setUidMachineService(UidMachineService uidMachineService) {
        this.uidMachineService = uidMachineService;
    }
}
