package com.qmth.boot.mysql.config;

import com.zaxxer.hikari.HikariDataSource;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;
import javax.sql.DataSource;

/**
 * MySQL数据源配置
 */
@Configuration
public class DataSourceAutoConfiguration {

    @Resource
    private MysqlConfig mysqlConfig;

    @Bean
    public DataSource dataSource() {
        HikariDataSource dataSource = new HikariDataSource();
        dataSource.setJdbcUrl(mysqlConfig.getUrl());
        dataSource.setUsername(mysqlConfig.getUsername());
        dataSource.setPassword(mysqlConfig.getPassword());
        dataSource.setMinimumIdle(mysqlConfig.getMinIdle());
        dataSource.setMaximumPoolSize(mysqlConfig.getMaxPoolSize());
        dataSource.setMaxLifetime(mysqlConfig.getMaxLifetime().toMillis());
        dataSource.setIdleTimeout(mysqlConfig.getIdleTimeout().toMillis());
        dataSource.setConnectionTimeout(mysqlConfig.getConnectionTimeout().toMillis());
        return dataSource;
    }

}
