package com.qmth.boot.redis.concurrent;

import com.qmth.boot.core.concurrent.service.ConcurrentService;
import com.qmth.boot.redis.constant.RedisConstant;
import org.redisson.api.RedissonClient;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReadWriteLock;

@Service
public class RedisConcurrentService implements ConcurrentService, RedisConstant {

    @Resource
    private RedissonClient redissonClient;

    @Override
    public Lock getLock(String name) {
        return redissonClient.getLock(LOCK_PREFIX.concat(KEY_SEPARATOR).concat(name));
    }

    @Override
    public ReadWriteLock getReadWriteLock(String name) {
        return redissonClient.getReadWriteLock(LOCK_PREFIX.concat(KEY_SEPARATOR).concat(name));
    }
}
