package com.qmth.boot.redis.uid;

import com.qmth.boot.core.uid.UidGenerator;
import com.qmth.boot.core.uid.service.UidMachineService;
import com.qmth.boot.redis.constant.RedisConstant;
import org.redisson.api.RedissonClient;

import javax.annotation.PreDestroy;
import javax.annotation.Resource;

public class RedisMachineService implements UidMachineService, RedisConstant {

    @Resource
    private RedissonClient redissonClient;

    private int machineId = -1;

    @Override
    public int getMachineId() {
        if (machineId > -1) {
            return machineId;
        }
        for (int i = 0; i <= UidGenerator.MAX_MACHINE_ID; i++) {
            if (redissonClient.getLock(MACHINE_ID_PREFIX.concat(KEY_SEPARATOR).concat(String.valueOf(i))).tryLock()) {
                machineId = i;
                return i;
            }
        }
        throw new RuntimeException("Get machineId from redis faile");
    }

    @PreDestroy
    public void destroy() {
        if (machineId > -1) {
            redissonClient.getLock(MACHINE_ID_PREFIX.concat(KEY_SEPARATOR).concat(String.valueOf(machineId)))
                    .unlockAsync();
        }
    }
}
